ReinforcementSquads = {
	{"light_inf","light_inf","light_inf","trooper","trooper"},
	{"quad","trike","light_inf", "light_inf"},
	{"trooper","trooper","trooper","trooper", "trooper"},
	}
ReinforcementLocations={}

Tick = function()
--needed for harkonnen airdrop powers
	local reinfocelocations = Map.ActorsInBox(Map.TopLeft, Map.BottomRight, 
			function(act)
				if act.Type=="waypoint_dummy" and noDuplicate(act, ReinforcementLocations)
				then
					dropAirReinforcements(act.Location,act.Owner)
					table.insert(ReinforcementLocations, act)
					return act
				else return nil
				end
			end
		)
	--
end

function noDuplicate(actor, actorlist)
  for _, value in pairs(actorlist) do
    if value == actor then
      return false
    end
  end
  return true
end

function dropAirReinforcements(location,owner)
	local squad
	if owner==atreides then squad=1 end
	if owner==harkonnen then squad=2 end
	if owner==ordos then squad=3 end
	--Carryall reinforcements
	local path = {ReinforcementBase[squad],location}
	local units = Reinforcements.ReinforceWithTransport(owner, "carryall.reinforce", ReinforcementSquads[squad], path, {path[2], path[1]})
	--reset spectator candy timer
	--T_reset[squad] = DateTime.GameTime
end

function replace_silos(player)
local actors = player.GetActors()
  for _, actor in pairs(actors) do
    if actor.Type == "silo" then
		local loc=actor.Location
		actor.Destroy()
		Actor.Create("advanced_silo", true, { Owner = atreides, Location = loc })
    end
  end
end

WorldLoaded = function()
Media.DisplayMessage("World loaded", "debug")


--players
atreides = Player.GetPlayer("Multi0")
harkonnen= Player.GetPlayer("Multi1")
ordos    = Player.GetPlayer("Multi2")


--reinforcements setup
ReinforcementBase={Actor210.Location, Actor211.Location, Actor212.Location}

--reinforcements bug warning
if ordos 
then
	Trigger.OnProduction(Actor142, 
		function(producer, produced)
			if produced.Type=="upgrade.outpost" and ordos.IsLocalPlayer 
			then
				Media.DisplayMessage( "Upgrade complete. Do not place any Air Reinforcements on top of concrete! There is a bug currently preventing the carryall from landing!", "WARNING",HSLColor.Red)
			elseif produced.Type=="upgrade.silo" and ordos.IsLocalPlayer
			then
				replace_silos(ordos)
			end 
		end
	)
end
if harkonnen
then
	Trigger.OnProduction(Actor155, 
		function(producer, produced)
			if produced.Type=="upgrade.outpost" and harkonnen.IsLocalPlayer 
			then
				Media.DisplayMessage( "Upgrade complete. Do not place any Air Reinforcements on top of concrete! There is a bug currently preventing the carryall from landing!", "WARNING",HSLColor.Red)
			elseif produced.Type=="upgrade.silo" and harkonnen.IsLocalPlayer
			then
				replace_silos(harkonnen)
			end 
		end
	)
end
if atreides
then
	Trigger.OnProduction(Actor181, 
		function(producer, produced)
			if produced.Type=="upgrade.outpost" and atreides.IsLocalPlayer 
			then
				Media.DisplayMessage( "Upgrade complete. Do not place any Air Reinforcements on top of concrete! There is a bug currently preventing the carryall from landing!", "WARNING",HSLColor.Red)
			elseif produced.Type=="upgrade.silo" and atreides.IsLocalPlayer
			then
				replace_silos(atreides)
			end 
		end
	)
end

Media.DisplayMessage("success", "debug")
end